#include "phi_master.h"

//SD constants
#define GAME_LOC_1 0
#define GAME_LOC_0 1
#define NUMBLOCK_LOC_3 2
#define NUMBLOCK_LOC_2 3
#define NUMBLOCK_LOC_1 4
#define NUMBLOCK_LOC_0 5
#define THRESH_ROTL_LOC 6
#define THRESH_ROTH_LOC 7
#define THRESH_LINL_LOC 8
#define THRESH_LINH_LOC 9
#define BATSTAT_LOC_1 10
#define BATSTAT_LOC_0 11
#define CUR_USED_LOC 0
#define LINROT_OFFSET 1
#define GAMENUM_OFFSET_1 2
#define GAMENUM_OFFSET_0 3
#define PROCTIME_OFFSET_1 4
#define PROCTIME_OFFSET_0 5
#define MAXVAL_OFFSET 6
#define RECORD_SIZE 6






#pragma config WDTEN = OFF
#pragma config MCLRE = OFF
#pragma config FOSC = INTIO67
#pragma config LVP = OFF
#pragma config DEBUG = OFF
#pragma config BOREN = OFF

void wait_on_wr(void)
{
	while(EECON1bits.WR)
		continue;
}

#pragma code high_vector_section=0x8
void
high_vector(void)
{
	_asm GOTO high_intr _endasm
}
#pragma code low_vector_section=0x18
void
low_vector(void)
{
	_asm GOTO low_intr _endasm
}
#pragma code

int count1 = 0;
int count2 = 0;
int count3 = 0;
int countADC = 0;
int countADC2 = 0;
int numCalc = 0;
int numAdcRead = 0;
const rom char *sendString;
int sendLength = 0;
int sendIndex = 0;
char sendDoneFlag = 0x00;
char sendVarFlag = 0x00;
char cmdInFlag = 0x00;
char txInProgressFlag = 0x00;
char testTimerFlag = 0x00;
char run_adc_flag = 0x00;
char adc_flag = 0x00;
char calc_flag = 0x00;
char debugAccelFlag = 0x00;
char DBGACFLAG = 0x00;
char A1 = 0x00;
char A2 = 0x00;
char A3 = 0x00;
char commandIn[6];
int rtnThrshRec, rtnThrshWrn, lnrThrshRec, lnrThrshWrn;
//long int rtnThrshRec2, rtnThrshWrn2, lnrThrshRec2, lnrThrshWrn2;
int cmdLen = 3;
int cmdIndex = 0;
char varString[7];
int X1, X2, X3, Y1, Y2, Y3, Z1, Z2, Z3;
int curAccum = 0;
int batteryStatus = 0;
int battStatusCounter = 0;
int batcnt1 = 0;
int batcnt2 = 0;
int batcnt3 = 0;
char batflg = 0xFF;

//SD Variables

//# of seconds the micro has been running since startup
unsigned int procRunTime = 0;
//unsigned char runTimeL = 0x00;
//unsigned char runTimeH = 0x00;
//the game number (used for timestamping collisions)
unsigned int gameNumber;
//# of blocks used on SD
unsigned long blocksUsed;
//# of recorded impacts
unsigned int numImpacts;

	
#pragma interruptlow low_intr
void low_intr (void) {
	unsigned long temp;
	PIR1bits.TMR2IF = 0;
	countADC++;
	TMR2 = 0;

	if (batflg == 0xFF){
		batcnt1++;
		if (batcnt1 == SECCNT1) {
			batcnt2++;
			batcnt1=0;
			if (batcnt2 == SECCNT2) {
				procRunTime++;
//				if (runTimeL > runTimeL+1) {
//					runTimeH++;
//				}
//				runTimeL++;
				batcnt3++;
				if (batcnt3 == 300) {//was 300
					batteryStatus -= 11;
					writeString("\n",1);
					printAccel("BS", batteryStatus/18);
					//WriteEEPROM(batteryStatus, BATSTAT_ADDR);
					//temp = SD_GetCurrBlock();
					SD_setStart();
					SD_readCurr();
					SD_SetSample(BATSTAT_LOC_1, (batteryStatus & 0xFF00)>>8);
					SD_SetSample(BATSTAT_LOC_0, batteryStatus & 0x00FF);
					SD_writeCurr();
					SD_SetCurrBlock(1+blocksUsed);
					SD_readCurr();
					batcnt3 = 0;
				}
				batcnt2 = 0;
			}
		}	
	}

	if (testTimerFlag == 0xFF) {
		count1++;
		if (count1 == SECCNT1) {
			count2++;
			count1=0;
			if (count2 == SECCNT2) {
				writeString("a sec!\n", 7);
				count2 = 0;
			}
		}	
	}

	if (DBGACFLAG == 0xFF) {
		count1++;
		if (count1 == SECCNT1) {
			count2++;
			count1=0;
			if (count2 == SECCNT2) {
				count3++;
				if (count3 == 2){
					AccP();
					count3 = 0;
				}
				count2 = 0;
			}
		}	
	}

	if (countADC == 10) {
		countADC = 0;
		countADC2++;
		if (countADC2 == 400){
			calc_flag = 0xFF;  //Do math.
			countADC2 = 0;
		} 
		adc_flag = 0xFF;
		numAdcRead = 0;
		numCalc = 0;
	}
}

#pragma interrupt high_intr
void high_intr(void) {
	char curChar;
	// this is where high interrupts are handled
	// possible interrupts: adc, usart
	if (PIR1bits.TXIF == 1) {
		PIR1bits.TXIF = 0;
		if (sendVarFlag == 0x00) {
			if (sendLength != sendIndex) {
				// transmit the next char
				curChar = sendString[sendIndex];
				WriteUSART(curChar);
				sendIndex++;
				if (sendIndex == sendLength) {
					sendDoneFlag = 0xFF;
					PIE1bits.TXIE = 0;
				}	
			}
		} else {
			if (sendLength != sendIndex) {
				curChar = varString[sendIndex];
				WriteUSART(curChar);
				sendIndex++;
				if (sendIndex == sendLength) {
					sendDoneFlag = 0xFF;
					sendVarFlag = 0x00;
					PIE1bits.TXIE = 0;
				}
			}
		}
	}
	if (PIR1bits.RCIF == 1) {
		PIR1bits.RCIF = 0;
		curChar = ReadUSART();
		if ((curChar == '>') && (cmdIndex == 0)) {
			cmdLen = 6;
		}
		else if (cmdIndex == 0) {
			cmdLen = 3;
		}
		if (cmdInFlag == 0x00) {	
			commandIn[cmdIndex] = curChar;
			cmdIndex++;
			if (cmdIndex == cmdLen) {
				cmdInFlag = 0xFF;
			}
		}
	}
	if (PIR1bits.ADIF == 1) {
		adc_flag = 0xFF;
		PIR1bits.ADIF = 0;
		numCalc++;
	}
}

void writeString (const rom char *str, int length) {
	sendString = str;
	sendLength = length;
	sendIndex = 0;
	sendDoneFlag = 0x00;
	PIE1bits.TXIE = 1;
	while(sendDoneFlag == 0x00);
}

void writeVar(unsigned int value) {
	int calcVal = value%1000;
	varString[0] = '>';
	varString[2] = ':';
	varString[3] = (char)((calcVal/100)+48);
	varString[4] = (char)(((calcVal%100)/10)+48);
	varString[5] = (char)(((calcVal%100)%10)+48);
	varString[6] = '\n';

	sendVarFlag = 0xFF;
	sendLength = 6;
	sendIndex = 0;
	sendDoneFlag = 0x00;
	PIE1bits.TXIE = 1;
	while (sendDoneFlag == 0x00);
}

void writeVariable(char str[], int length) {
	int i, len;
	for (i = 0; i < length; i++) {
		if (i == 7) break;
		varString[i] = str[i];
	}
	sendLength = i;
	sendVarFlag = 0xFF;
	sendIndex = 0;
	sendDoneFlag = 0x00;
	PIE1bits.TXIE = 1;
	while(sendDoneFlag == 0x00);
}

void writeCharacter(char c) {
	varString[0] = c;
	sendLength = 1;
	sendVarFlag = 0xFF;
	sendIndex = 0;
	sendDoneFlag = 0x00;
	PIE1bits.TXIE = 1;
	while(sendDoneFlag == 0x00) ;
}

void main (void)
{
	unsigned int result;
	int odd = 0;
	int three_multiple = 0;
	char c = 0x0C;
	int numsamples = 0;
	
	//batReset();

	init();

	while (1) {
		if ((cmdInFlag == 0xFF) && (txInProgressFlag == 0x00)) {
			checkCmd();
		}
		if ((txInProgressFlag == 0xFF) && (sendDoneFlag = 0xFF)) {
			sendDoneFlag = 0x00;
			txInProgressFlag = 0x00;
			cmdInFlag = 0x00;
			cmdIndex = 0;
		}

		if (adc_flag == 0xFF) {
			// check numCalc is odd
			odd = numCalc%2;
			if (odd == 1) {
				// yes: get adc result, increment numcalc and numAdcRead, set calc flag
				result = ReadADC();
				result &= 0xFFFC;
				setVar(result, numAdcRead);
				numCalc++;
				numAdcRead++;
				//calc_flag = 0xFF;
			}
			// set next adc channel, begin conversion, setADC flag to 0
			if (numAdcRead < 9) {
				SetChanADC(getAdcChannel(numAdcRead));
				ConvertADC();
			}
			adc_flag = 0x00;
		}

		if (calc_flag == 0xFF) {
			calc();
		}
	}
}

void init(void) {
	int i, j;
	int status;
	i = 0;
	j = 0;

	RCONbits.SBOREN = 0;
	varString[0] = '>';
	varString[1] = ' ';
	varString[2] = ':';
	debugAccelFlag = 0x00;

	TRISA &= 0b01101111;
	PORTA = 0b00000000;
	TRISC &= 0b10010011;
	PORTC = 0b00000000;
	TRISD &= 0b11101111;
	PORTD = 0b00000000;
	
	// read from EEPROM
	EECON1bits.EEPGD = 0;
	EEADR = LNR_THRSH_REC_ADDR;
	EECON1bits.RD = 1;
	lnrThrshRec = (int)EEDATA;
	if (lnrThrshRec  <= 0){
		lnrThrshRec = 50;
	}

	EECON1bits.EEPGD = 0;
	EEADR = LNR_THRSH_WRN_ADDR;
	EECON1bits.RD = 1;
	lnrThrshWrn = (int)EEDATA;
	if (lnrThrshWrn  <= 0){
		lnrThrshWrn = 50;
	}

	EECON1bits.EEPGD = 0;
	EEADR = RTN_THRSH_REC_ADDR;
	EECON1bits.RD = 1;
	rtnThrshRec = (int)EEDATA;
	if (rtnThrshRec  <= 0){
		rtnThrshRec = 50;
	}

	EECON1bits.EEPGD = 0;
	EEADR = RTN_THRSH_WRN_ADDR;
	EECON1bits.RD = 1;
	rtnThrshWrn = (int)EEDATA;
	if (rtnThrshWrn <= 0){
		rtnThrshWrn = 50;
	}

	EECON1bits.EEPGD = 0;
	EEADR = BATSTAT_ADDR;
	EECON1bits.RD = 1;
	batteryStatus = (int)EEDATA;
	if (batteryStatus  <= 0){
		batteryStatus = 1800;
	}
	
	// Fosc = 16MHz
	OSCCONbits.IRCF0 = 1;
	OSCCONbits.IRCF1 = 1;
	OSCCONbits.IRCF2 = 1;
	WDTCON = 0; // WDT disabled

	// enable USART
	OpenUSART( USART_TX_INT_OFF & USART_RX_INT_ON & USART_ASYNCH_MODE & USART_EIGHT_BIT & USART_CONT_RX & USART_BRGH_LOW, 25);

	// open timer 2
	OpenTimer2 ( TIMER_INT_ON & T2_PS_1_4 & T2_POST_1_1 );
	PR2 = 0xFF;
	
	initAccels();

	// Enable ADC interrupts
	PIE1bits.ADIE = 1;
	PIR1bits.ADIF = 0;

	// enable interrupts and interrupt priority
	RCONbits.IPEN = 1;
	PIR1 = 0;
	PIE1bits.TMR2IE = 1;
	IPR1bits.TMR2IP = 0;
	INTCONbits.GIEH = 1;
	INTCONbits.GIEL = 1;

	//SD Card
	//InitSPI();
	setup_SDSPI();
	SD_setStart();
	initFromSD();
	writeString("OK",2);
}

void initAccels(void) {
	int i = 0;
	int j = 0;
	
	OpenADC( ADC_FOSC_32 & ADC_RIGHT_JUST & ADC_0_TAD,
			 ADC_CH0 & ADC_CH1 & ADC_CH4 & ADC_CH5 & ADC_CH8 & ADC_CH9 & ADC_CH10 & ADC_CH11 & ADC_CH12 &
			 ADC_INT_ON & ADC_VREFPLUS_EXT & ADC_VREFMINUS_EXT,
			 0);
	Delay10TCYx(5);

	for (j=0;j<15000;j++){
		i++;
		i--;
	}
	if (TestAccOne()){
		i++;
		A1=0xFF;
	}
	for (j=0;j<3000;j++){
		i++;
		i--;
	}
	if (TestAccTwo()){
		i++;
		A2=0xFF;
	}
	for (j=0;j<3000;j++){
		i++;
		i--;
	}
	if (TestAccThree()){
		i++;
		A3=0xFF;
	}
	for (j=0;j<3000;j++){
		i++;
		i--;
	}
	if( i == 3 ){
		run_adc_flag = 0x00;
		while(1);
	}else if(i == 2){
		run_adc_flag = 0x00;
		while(1);
	}else{
		run_adc_flag = 0xFF;
		i=0;
	}
}

void checkCmd(void) {
	char testStr[] = "Stop it guys... I have had enough!";
	char retStr[] = "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";
	unsigned char tester;
	int testSD = 0;
	int numRun = 0;
	int timeWaster = 0; 
	int i=0;
	unsigned char a;
	unsigned char b;
	
	
	int counter;
	txInProgressFlag = 0xFF;

	// compare individual characters of command and print a string telling type of command received
	
	if (commandIn[0] == '?') {
		if (commandIn[2] == ':') {
			if (commandIn[1] == 'A') {
				ReadVariable('A');
				return;
			} else if (commandIn[1] == 'B') {
				ReadVariable('B');
				return;
			} else if (commandIn[1] == 'C') {
				ReadVariable('C');
				return;
			} else if (commandIn[1] == 'D') {
				ReadVariable('D');
				return;
			}
		}else if(commandIn[1] == 'B'){ //?BS
			if (commandIn[2] == 'S') {
				if (batcnt3 > 55){
					batteryStatus -= (int)(11*((float)(batcnt3/300.0)));
					batcnt3 = 0;
				}
				writeString("\n",1);
				printAccel("BS", (int)(batteryStatus/18));
				return;
			}
		}
	} else if (commandIn[0] == '>') {
		if (commandIn[2] == ':') {
			if (commandIn[1] == 'A') {
				SetVariable('A');
				return;
			} else if (commandIn[1] == 'B') {
				SetVariable('B');				
				return;	
			} else if (commandIn[1] == 'C') {
				SetVariable('C');				
				return;
			} else if (commandIn[1] == 'D') {
				SetVariable('D');				
				return;
			} 	
		} 
		else if (commandIn[1] == 'T') {
			if ((commandIn[2] == 'I') && (commandIn[3] == 'M') &&
				(commandIn[4] == 'E') && (commandIn[5] == 'R')) {
				//writeString("Easter Egg! ", 12);
				if (testTimerFlag == 0x00) {
					testTimerFlag = 0xFF;
				} else {
					testTimerFlag = 0x00;
				}
				return;
			}
		} else if (commandIn[1] == 'K') {
			if ((commandIn[2] == 'E') && (commandIn[3] == 'V') &&
				(commandIn[4] == 'I') && (commandIn[5] == 'N')) {
				//writeString("Easter Egg! ", 12);
//				SD_setStart();
//				for (i = 0; i<24; i++){
//					SD_SetSample(i,testStr[i]);
//				}
//				SD_writeCurr();
				writeSDRec(67);
				varString[1]='B';
				writeVar(blocksUsed);
				varString[1]='T';
				writeVar(procRunTime/1000);
				varString[1]='U';
				writeVar(procRunTime);
//				i = (((int)runTimeH) << 8) | runTimeL;
//				varString[1]='?';
//				writeVar(i);
				//writeString("Kevin is the mystic\n", 20);
				return;
			}
		} else if (commandIn[1] == 'M') {
			if ((commandIn[2] == 'I') && (commandIn[3] == 'K') &&
				(commandIn[4] == 'E') && (commandIn[5] == 'O')) {
//			//	writeString("Easter Egg! ", 12);
//				//while(1){
//				SD_setStart();
//				SD_readCurr();
//				//if (testSD != 0){
//				//	writeString("Read Failure!",13);
//				//	while(sendDoneFlag == 0x00);
//				//}
//				for (i = 0; i<24; i++){
//					retStr[i]=SD_GetSample(i);
//				}
//				if (retStr[0] == testStr[0]){
//					writeVariable(retStr, 24);
//					//writeString("Win",3);
//				} else{
//					//writeString("Fail",4);
//					//writeString("-->",3);
//					//while(sendDoneFlag == 0x00);
//					//writeVariable(testStr,7);
//					//while(sendDoneFlag == 0x00);
//					writeString("\n",1);
//					while(sendDoneFlag == 0x00);
//					writeVariable(retStr, 7);
//					while(sendDoneFlag == 0x00);
//					//writeString("<--",3);
//					//while(sendDoneFlag == 0x00);
//				}
				a = 0x01;
				b = 0xFF;
				//i = (((int)a)<<8) | b;
				varString[1] = 'T';
				writeVar((unsigned int)b);
				//writeString((rom char *)retStr,7);				
				//writeString("\n", 1);
				return;
			}
		} else if (commandIn[1] == 'A') {
			if ((commandIn[2] == 'D') && (commandIn[3] == 'A') &&
				(commandIn[4] == 'M') && (commandIn[5] == 'B')) {
				writeString("Easter Egg! ", 12);
//				tester = 0xFF;
//				varString[1]='u';
				


//				initFromSD();
//				varString[1]='G';
//				writeVar(gameNumber);
//				varString[1]='B';
//				writeVar(blocksUsed);
//				varString[1]='R';
//				writeVar(rtnThrshRec);
//				varString[1]='S';
//				writeVar(rtnThrshWrn);
//				varString[1] ='L';
//				writeVar(lnrThrshRec);
//				varString[1] = 'M';
//				writeVar(lnrThrshWrn);
//				varString[1] = 'B';
//				writeVar(batteryStatus);
//				writeSDRec(1);
//				testCurSDVals();
//				writeSDRec(2);
//				testCurSDVals();
//				writeSDRec(3);
//				SD_readCurr();
//				testCurSDVals();
				return;
			}

		} else if (commandIn[1] == 'D') {
			if ((commandIn[2] == 'R') && (commandIn[3] == 'E') &&
				(commandIn[4] == 'W') && (commandIn[5] == 'C')) {
				writeString("Where is he?\n", 13);
				printSDRecords();
				return;
			}
			if ((commandIn[2] == 'B') && (commandIn[3] == 'G') &&
				(commandIn[4] == 'A') && (commandIn[5] == 'C')) {
				//writeString("Easter Egg! ", 12);
				//debugAccelFlag = 0xFF;
				//DBGACFLAG = 0xFF;
				AccP();
				if (DBGACFLAG == 0x00) {
					DBGACFLAG = 0xFF;
				} else {
					DBGACFLAG = 0x00;
				}
				return;
			}
		} else if(commandIn[1] == 'R') {
			if ((commandIn[2] == 'S') && (commandIn[3] == 'T') &&
				(commandIn[4] == 'S') && (commandIn[5] == 'D')) {			
				resetSD();
				return;
			}
		} else if(commandIn[1] == 'P') {
			if ((commandIn[2] == 'R') && (commandIn[3] == 'T') &&
				(commandIn[4] == 'S') && (commandIn[5] == 'D')) {			
				printSDRecords();
				return;
			}
		}
	}

	writeString("Invalid Command\n", 16);
}

//void testCurSDVals(void){
//	unsigned char tester;
//	varString[1] = '+';
//	writeVar( (int) SD_GetCurrBlock());
//	
//	varString[1] = '0';
//	tester = SD_GetSample(0);
//	writeVar((int)tester);
//	varString[1] = '1';
//	tester = SD_GetSample(1);
//	writeVar((int)tester);
//	varString[1] = '2';
//	tester = SD_GetSample(2);
//	writeVar((int)tester);
//	varString[1] = '3';
//	tester = SD_GetSample(3);
//	writeVar((int)tester);
//	varString[1] = '4';
//	tester = SD_GetSample(4);
//	writeVar((int)tester);
//	varString[1] = '5';
//	tester = SD_GetSample(5);
//	writeVar((int)tester);
//	varString[1] = '6';
//	tester = SD_GetSample(6);
//	writeVar((int)tester);
//	varString[1] = '7';
//	tester = SD_GetSample(7);
//	writeVar((int)tester);
//	varString[1] = '8';
//	tester = SD_GetSample(8);
//	writeVar((int)tester);
//	varString[1] = '9';
//	tester = SD_GetSample(9);
//	writeVar((int)tester);
//	varString[1] = 'A';
//	tester = SD_GetSample(10);
//	writeVar((int)tester);
//	varString[1] = 'B';
//	tester = SD_GetSample(11);
//	writeVar((int)tester);	
//	varString[1] = 'C';
//	tester = SD_GetSample(12);
//	writeVar((int)tester);	
//	varString[1] = 'D';
//	tester = SD_GetSample(13);
//	writeVar((int)tester);	
//	writeString("\n",1);
//}

void SetVariable(char A){
	//int Value;
	int Value;

	Value = commandIn[5] - 48;
	Value += (commandIn[4] - 48)*10;
	Value += (commandIn[3] - 48)*100;
    if (A == 'A'){
		lnrThrshRec = Value;
//		WriteEEPROM(Value, LNR_THRSH_REC_ADDR);
		SD_setStart();
		SD_readCurr();
		SD_SetSample(THRESH_LINL_LOC, lnrThrshRec & 0x00FF);
		SD_writeCurr();
		SD_SetCurrBlock(1+blocksUsed);
		SD_readCurr();
	}else if(A == 'B'){
		lnrThrshWrn = Value;
//		WriteEEPROM(Value, LNR_THRSH_WRN_ADDR);
		SD_setStart();
		SD_readCurr();
		SD_SetSample(THRESH_LINH_LOC, lnrThrshWrn & 0x00FF);
		SD_writeCurr();
		SD_SetCurrBlock(1+blocksUsed);
		SD_readCurr();
	}else if(A == 'C'){
		rtnThrshRec = Value;
//		WriteEEPROM(Value, RTN_THRSH_REC_ADDR);
		SD_setStart();
		SD_readCurr();
		SD_SetSample(THRESH_ROTL_LOC, rtnThrshRec & 0x00FF);
		SD_writeCurr();
		SD_SetCurrBlock(1+blocksUsed);
		SD_readCurr();
	}else if(A == 'D'){
		rtnThrshWrn = Value;
//		WriteEEPROM(Value, RTN_THRSH_WRN_ADDR);
		SD_setStart();
		SD_readCurr();
		SD_SetSample(THRESH_ROTH_LOC, rtnThrshWrn & 0x00FF);
		SD_writeCurr();
		SD_SetCurrBlock(1+blocksUsed);
		SD_readCurr();		
	}
	writeString("**",2);
}

void ReadVariable(char A){
	if (A == 'A'){
		varString[1] = 'A';
		writeVar((int)lnrThrshRec);
	}else if(A == 'B'){
		varString[1] = 'B';
		writeVar((int)lnrThrshWrn);
	}else if(A == 'C'){
		varString[1] = 'C';
		writeVar((int)rtnThrshRec);
	}else if(A == 'D'){
		varString[1] = 'D';
		writeVar((int)rtnThrshWrn);
	}
}

void WriteEEPROM(int value, char addr) {
	
	// convert value to a single character
	char value_c = (char)value;

	EECON1bits.EEPGD = 0;
	EECON1bits.WREN = 1;
	EEADR = addr;
	EEDATA = value_c;

	// disable interrupts
	INTCONbits.GIEH = 0;
	INTCONbits.GIEL = 0;

	EECON2 = 0x55;
	EECON2 = 0xAA;
	EECON1bits.WR = 1;

	while (!PIR2bits.EEIF) ;
	PIR2bits.EEIF = 0;

	// re-enable interrupts
	INTCONbits.GIEH = 1;
	INTCONbits.GIEL = 1;
}

int TestAccOne(void){
int j;
	for (j=0; j < 10000; j++){
		if (j == 0){
    		PORTD = 0b00010000;
		}else if (j == 5000){
			PORTD = 0b00000000;
		}
		if (j == 2500){
			if (PORTDbits.RD5 == 0){
				writeString("Accelerometer 1 Test Fails (First)\n", 36);
				return 1;
			}
		}
		if (j == 7500){
			if (PORTDbits.RD5 == 1){
				writeString("Accelerometer 1 Test Fails (Second)\n", 37);
				return 1;
			}
		}
	}
return 0;
}

int TestAccTwo(void){
int j;
	for (j=0; j < 10000; j++){
		if (j == 0){
    		PORTA = 0b00010000;
		}else if (j == 5000){
			PORTA = 0b00000000;
		}
		if (j == 2500){
			if (PORTDbits.RD6 == 0){
				writeString("Accelerometer 2 Test Fails (First)\n", 36);
				return 1;
			}
		}
		if (j == 7500){
			if (PORTDbits.RD6 == 1){
				writeString("Accelerometer 2 Test Fails (Second)\n", 37);
				return 1;
			}
		}
	}
return 0;
}

int TestAccThree(void){
int j;
	for (j=0; j < 10000; j++){
		if (j == 0){
    		PORTA = 0b10000000;
		}else if (j == 5000){
			PORTA = 0b00000000;
		}
		if (j == 2500){
			if (PORTCbits.RC0 == 0){
				writeString("Accelerometer 3 Test Fails (First)\n", 36);
				return 1;
			}
		}
		if (j == 7500){
			if (PORTCbits.RC0 == 1){
				writeString("Accelerometer 3 Test Fails (Second)\n", 37);
				return 1;
			}
		}
	}
return 0;
}

char getAdcChannel(int chan) {
	// get ADC value and set it to proper variable based on numAdcRead
	char channel;
	switch(chan) {
		case 0:
			channel = ADC_CH12;	// X1
			break;
		case 1:
			channel = ADC_CH8; // Y1
			break;
		case 2:
			channel = ADC_CH10; // Z1
			break;
		case 3:
			channel = ADC_CH11; // X2
			break;
		case 4:
			channel = ADC_CH0;  // Y2
			break;
		case 5:
			channel = ADC_CH9;  // Z2
			break;
		case 6:
			channel = ADC_CH4; // X3
			break;
		case 7:
			channel = ADC_CH5; // Y3
			break;
		default:
			channel = ADC_CH1; // Z3
			break;
	}
	return channel;
}

void setVar(unsigned int val, int num) {
	int myVal = (int)val;
	if (myVal < 367) myVal = 367;

	myVal = myVal-695;
	myVal = (int)((float)myVal/2.87719);

	switch(num) {
		case 0:
			if (abs(X1) < abs(myVal)){
				X1 = -myVal;
			}
			break;
		case 1:
			if (abs(Y1) < abs(myVal)){
				Y1 = myVal;
			}
			break;
		case 2:
			if (abs(Z1) < abs(myVal)){
				Z1 = myVal;
			}
			break;
		case 3:
			if (abs(X2) < abs(myVal)){
				X2 = myVal;
			}
			break;
		case 4:
			if (abs(Y2) < abs(myVal)){
				Y2 = -myVal;
			}
			break;
		case 5:
			if (abs(Z2) < abs(myVal)){
				Z2 = -myVal;
			}
			break;
		case 6:
			if (abs(X3) < abs(myVal)){
				X3 = myVal;
			}
			break;
		case 7:
			if (abs(Y3) < abs(myVal)){
				Y3 = myVal;
			}
			break;
		default:
			if (abs(Z3) < abs(myVal)){
				Z3 = myVal;
			}
			break;
	}
}

int getVar(int num) {
	switch(num) {
		case 0:
			return X1;
		case 1:
			return Y1;
		case 2:
			return Z1;
		case 3:
			return X2;
		case 4:
			return Y2;
		case 5:
			return Z2;
		case 6:
			return X3;
		case 7:
			return Y3;
		default:
			return Z3;
	}
}

void AccP(void){
	int magnitude;	

	printAccel("X1", X1);
	while (sendDoneFlag == 0x00) ;
	writeString(", ", 2);
	while (sendDoneFlag == 0x00) ;
	printAccel("Y1", Y1);
	while (sendDoneFlag == 0x00) ;
	writeString(", ", 2);
	while (sendDoneFlag == 0x00) ;
	printAccel("Z1", Z1);
	while (sendDoneFlag == 0x00) ;
	writeString(", ", 2);

	// calculate magnitude
	magnitude = X1*X1 + Y1*Y1 + Z1*Z1;
	magnitude = (int)sqrt((float)magnitude);
	while(sendDoneFlag == 0x00);
	printAccel("MG", magnitude);
	while(sendDoneFlag == 0x00);
	writeString("\n",1);

	while (sendDoneFlag == 0x00) ;
	printAccel("X2", X2);
	while (sendDoneFlag == 0x00) ;
	writeString(", ", 2);
	while (sendDoneFlag == 0x00) ;
	printAccel("Y2", Y2);
	while (sendDoneFlag == 0x00) ;
	writeString(", ", 2);
	while (sendDoneFlag == 0x00) ;
	printAccel("Z2", Z2);
	while (sendDoneFlag == 0x00) ;
	writeString(", ", 2);

	magnitude = X2*X2 + Y2*Y2 + Z2*Z2;
	magnitude = (int)sqrt((float)magnitude);
	while(sendDoneFlag == 0x00);
	printAccel("MG", magnitude);
	while(sendDoneFlag == 0x00);
	writeString("\n",1);

	while (sendDoneFlag == 0x00) ;
	printAccel("X3", X3);
	while (sendDoneFlag == 0x00) ;
	writeString(", ", 2);
	while (sendDoneFlag == 0x00) ;
	printAccel("Y3", Y3);
	while (sendDoneFlag == 0x00) ;
	writeString(", ", 2);
	while (sendDoneFlag == 0x00) ;
	printAccel("Z3", Z3);
	while (sendDoneFlag == 0x00) ;
	writeString(", ", 2);

	magnitude = X3*X3 + Y3*Y3 + Z3*Z3;
	magnitude = (int)sqrt((float)magnitude);
	while(sendDoneFlag == 0x00);
	printAccel("MG", magnitude);

	while (sendDoneFlag == 0x00) ;
	writeString("\n", 1);	
	while (sendDoneFlag == 0x00) ;
}

void printAccel(const rom char *str, int accel) {
	char negative;
	int value = 0;
	if (accel < 0) {
		value = -accel;
		negative = 1;
	} else {
		value = accel;
		negative = 0;
	}

	value = value%1000;
	varString[0] = str[0];
	varString[1] = str[1];
	varString[2] = ':';
	if (negative == 0) {
		varString[3] = (char)((value/100)+48);
		varString[4] = (char)((value%100)/10+48);
		varString[5] = (char)((value%100)%10+48);
		sendLength = 6;
	} else {
		varString[3] = '-';
		varString[4] = (char)((value/100)+48);
		varString[5] = (char)((value%100)/10+48);
		varString[6] = (char)((value%100)%10+48);
		sendLength = 7;
	}
	sendVarFlag = 0xFF;
	sendIndex = 0;
	sendDoneFlag = 0x00;
	PIE1bits.TXIE = 1;
}

int abs (int i)
{
    return i < 0 ? -i : i;
}

void calc(void){
	int T_X1 = X1;
	int T_Y1 = Y1;
	int T_Z1 = Z1;
	int T_X2 = X2;
	int T_Y2 = Y2;
	int T_Z2 = Z2;
	int T_X3 = X3;
	int T_Y3 = Y3;
	int T_Z3 = Z3;
	int a1Resultant = 0;
	int a2Resultant = 0;
	int a3Resultant = 0;
	int magnitude = 0;
	X1 = 0;
	X2 = 0;
	X3 = 0;
	Y1 = 0;
	Y2 = 0;
	Y3 = 0;
	Z1 = 0;
	Z2 = 0;
	Z3 = 0;
	calc_flag = 0x00;
	if (A1 == 0xFF){
		a1Resultant = (int) sqrt((float)(T_Y1*T_Y1+T_Z1*T_Z1));
	} else if (A2 == 0xFF){
		a1Resultant = (int) sqrt((float)(T_X1*T_X1+T_Z1*T_Z1));
	} else if (A3 == 0xFF){
		a1Resultant = (int) sqrt((float)(T_Y1*T_Y1+T_X1*T_X1));
	}else{
		a1Resultant = (int) sqrt((float)(T_X1*T_X1 + T_Y1*T_Y1 + T_Z1*T_Z1));
	}
	if (A1 == 0xFF){
		a2Resultant = (int) sqrt((float)(T_Y2*T_Y2+T_Z2*T_Z2));
	} else if (A2 == 0xFF){
		a2Resultant = (int) sqrt((float)(T_X2*T_X2+T_Z2*T_Z2));
	} else if (A3 == 0xFF){
		a2Resultant = (int) sqrt((float)(T_Y2*T_Y2+T_X2*T_X2));
	}else{
		a2Resultant = (int) sqrt((float)(T_X2*T_X2 + T_Y2*T_Y2 + T_Z2*T_Z2));
	}
	if (A1 == 0xFF){
		a3Resultant = (int) sqrt((float)(T_Y3*T_Y3+T_Z3*T_Z3));
	} else if (A2 == 0xFF){
		a3Resultant = (int) sqrt((float)(T_X3*T_X3+T_Z3*T_Z3));
	} else if (A3 == 0xFF){
		a3Resultant = (int) sqrt((float)(T_Y3*T_Y3+T_X3*T_X3));
	}else{
		a3Resultant = (int) sqrt((float)(T_X3*T_X3 + T_Y3*T_Y3 + T_Z3*T_Z3));
	}
	if (debugAccelFlag == 0xFF) {
		AccP();
		debugAccelFlag = 0x00;	
	}
	
	magnitude = a1Resultant;
	if (magnitude < a2Resultant) {
		magnitude = a2Resultant;
	}					

	if (magnitude < a3Resultant) {
		magnitude = a3Resultant;
	}

	if (magnitude > lnrThrshWrn) {
		writeSDRec((unsigned int)magnitude);
		printAccel("!!", magnitude);
		while(sendDoneFlag = 0x00);
	}
	else if (magnitude > lnrThrshRec) {
		writeSDRec((unsigned int)magnitude);
		//printAccel("~~", magnitude);
		while(sendDoneFlag = 0x00);
	}
}
//This needs to be called during initialization to load all saved values from the SD card
void initFromSD(void){
	int temp;	

	SD_setStart();
	SD_readCurr();
//testCurSDVals();
	gameNumber = (((unsigned int)SD_GetSample(GAME_LOC_1))<<8) | (SD_GetSample(GAME_LOC_0));
	temp = gameNumber + 1;
	SD_SetSample(GAME_LOC_1, (temp & 0xFF00) >> 8);
	SD_SetSample(GAME_LOC_0, temp & 0x00FF);
	blocksUsed = (((unsigned long)SD_GetSample(NUMBLOCK_LOC_3))<<24) | (((unsigned long)SD_GetSample(NUMBLOCK_LOC_2)) << 16) | 
					(((unsigned long)SD_GetSample(NUMBLOCK_LOC_1)) << 8) | (((unsigned long)SD_GetSample(NUMBLOCK_LOC_0)));
	rtnThrshRec = (unsigned int) SD_GetSample(THRESH_ROTL_LOC);
	rtnThrshWrn = (unsigned int) SD_GetSample(THRESH_ROTH_LOC);
	lnrThrshRec = (unsigned int) SD_GetSample(THRESH_LINL_LOC);
	lnrThrshWrn = (unsigned int) SD_GetSample(THRESH_LINH_LOC);
	batteryStatus = (((unsigned int)SD_GetSample(BATSTAT_LOC_1))<<8) | (SD_GetSample(BATSTAT_LOC_0));
	SD_writeCurr();
	SD_SetCurrBlock(SD_GetCurrBlock() + blocksUsed);
	SD_readCurr();
	
}

//Resets values in initial block of the SD to default
//Format of first block is as follows (type[# bytes]):
//(game #[2]) (# of blocks utilized on card[2]) (thresholds rot low [1])
//(threshold rot high [1]) (threshold lin low[1]) threshold lin high [1])
// (batery status [2])
void resetSD(void){	
	SD_setStart();
	SD_SetSample(GAME_LOC_1, 0x00);//set game # to 0
	SD_SetSample(GAME_LOC_0, 0x01);
	SD_SetSample(NUMBLOCK_LOC_3, 0x00);//set # of blocks to 0
	SD_SetSample(NUMBLOCK_LOC_2, 0x00);
	SD_SetSample(NUMBLOCK_LOC_1, 0x00);
	SD_SetSample(NUMBLOCK_LOC_0, 0x00);
	SD_SetSample(THRESH_ROTL_LOC, 0x14);//NEED DEFAULT VALUES OF THRESHOLDS HERE (maybe)
	SD_SetSample(THRESH_ROTH_LOC, 0x46);
	SD_SetSample(THRESH_LINL_LOC, 0x14);
	SD_SetSample(THRESH_LINH_LOC, 0x46);
	SD_SetSample(BATSTAT_LOC_1, 0x07);//Baterry Status init to 1800
	SD_SetSample(BATSTAT_LOC_0, 0x08);
	SD_writeCurr();
	newBlock(SD_GetCurrBlock() + 1);
	initFromSD();
}

//loc contains the block number of the block to be used as new
void newBlock(unsigned long loc){
	unsigned long temp;

//writeString("newBlock",8);
//varString[1] = 'N';
//writeVar((int)loc);
	SD_setStart();
	SD_readCurr();
	temp = (((unsigned long)SD_GetSample(NUMBLOCK_LOC_3)) << 24) | 
			(((unsigned long)SD_GetSample(NUMBLOCK_LOC_2)) << 16)|
			(((unsigned long)SD_GetSample(NUMBLOCK_LOC_1)) << 8) | 
			SD_GetSample(NUMBLOCK_LOC_0);
	temp++;
//varString[1] = 'T';
//writeVar((int)temp);
	blocksUsed = temp;//Increment the number of blocks that are used
	SD_SetSample(NUMBLOCK_LOC_3, (temp & 0xFF000000)>>24);
	SD_SetSample(NUMBLOCK_LOC_2, (temp & 0x00FF0000)>>16);
	SD_SetSample(NUMBLOCK_LOC_1, (temp & 0x0000FF00)>>8);
	SD_SetSample(NUMBLOCK_LOC_0,temp & 0x000000FF);
	SD_writeCurr();
	SD_SetCurrBlock(loc);
	SD_SetSample(CUR_USED_LOC, 0x00); // set the number of records in this block to 0
	SD_writeCurr();
}

//level is the value that is to be recorded
void writeSDRec( unsigned char level){
	unsigned int curLoc;
//testCurSDVals();
	//63 because 1 Byte is taken up with the current count of the records in this block
	if ( SD_GetSample(0) >= (unsigned char)((SD_BLOCK_SIZE-1)/RECORD_SIZE)){//this block is full so we need a new one
		newBlock(SD_GetCurrBlock() + 1);
	}
//varString[1] = 'G';
//writeVar((int)SD_GetSample(0));
//varString[1] = 'D';
//writeVar((int)(SD_BLOCK_SIZE/RECORD_SIZE));
//writeString("\n",1);
	SD_readCurr();
	curLoc = (int) SD_GetSample(CUR_USED_LOC);
	SD_SetSample(CUR_USED_LOC, (curLoc & 0x00FF )+ 1);
	curLoc = curLoc * RECORD_SIZE;
	SD_SetSample(curLoc+LINROT_OFFSET, 0x00);
	SD_SetSample(curLoc+GAMENUM_OFFSET_1, (gameNumber & 0xFF00)>> 8);
	SD_SetSample(curLoc+GAMENUM_OFFSET_0, (gameNumber & 0x00FF));
	SD_SetSample(curLoc+PROCTIME_OFFSET_1, (procRunTime & 0xFF00) >> 8);
	SD_SetSample(curLoc+PROCTIME_OFFSET_0, (procRunTime & 0x00FF));
//	SD_SetSample(curLoc+PROCTIME_OFFSET_1, runTimeH);
//	SD_SetSample(curLoc+PROCTIME_OFFSET_0, runTimeL);
	SD_SetSample(curLoc+MAXVAL_OFFSET, level);
	SD_writeCurr();
	return;
}



//Sorry, but none of this code is tested.  Please don't delete it though :)
//  Cya guys in the morning, Drew
void printSDRecords (void){
	unsigned int recNum;
	unsigned int recLoc;
	unsigned long blockNum;
	unsigned long startBlock;
	unsigned int tempi;
	unsigned char tempc;
	SD_setStart();
	startBlock = SD_GetCurrBlock();
	blockNum = 1;
	while (blockNum <= blocksUsed){
//		writeString("Run through",11);
		SD_SetCurrBlock(startBlock+blockNum);
//		varString[1] = 'S';
//		writeVar((int) startBlock);
//		varString[1] = 'b';
//		writeVar((int) blockNum);
		SD_readCurr();
		recNum = 0;
//		testCurSDVals();
		while (recNum < (int)SD_GetSample(CUR_USED_LOC)){
//			writeString("here",4);
			recLoc = recNum * RECORD_SIZE;
			tempc = SD_GetSample(recLoc + LINROT_OFFSET);
			if (tempc == 0x00){
				varString[1] = 'L';
			} else{
				varString[1] = 'R';
			}
			tempc = SD_GetSample(recLoc + MAXVAL_OFFSET);
			writeVar((unsigned int) tempc);
//			tempc = SD_GetSample(recLoc+GAMENUM_OFFSET_1);
//			tempi = (unsigned int)(tempc << 8);
//			tempc = SD_GetSample(recLoc+GAMENUM_OFFSET_0);
//			tempi += (unsigned int)tempc;
			tempi = (((unsigned int)SD_GetSample(recLoc+GAMENUM_OFFSET_1)) << 8) | 
						SD_GetSample(recLoc+GAMENUM_OFFSET_0);
			varString[1] = 'G';
			writeVar(tempi);
//			tempc = SD_GetSample(recLoc+PROCTIME_OFFSET_1);
//			tempi = (unsigned int)(tempc << 8);
//			tempc = SD_GetSample(recLoc+PROCTIME_OFFSET_0);
//			tempi += (unsigned int)tempc;

			tempi = (((unsigned int)SD_GetSample(recLoc+PROCTIME_OFFSET_1)) << 8) | 
						SD_GetSample(recLoc+PROCTIME_OFFSET_0);
//			varString[1] = '1';
//			writeVar((unsigned int)SD_GetSample(recLoc+PROCTIME_OFFSET_1));
//			varString[1] = '2';
//			writeVar((unsigned int)SD_GetSample(recLoc+PROCTIME_OFFSET_0));
			
			varString[1] = 'T';
			writeVar(tempi / 1000);
			varString[1] = 'U';
			writeVar(tempi);
			writeString("\n",1);
			recNum++;
		}
		blockNum++;
	}
	return;
}
